#!env python
"""
Copyright (C) 2000 Frdric Laurent

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

mailto:flrt@free.fr
"""

from pawt import swing
from java import awt
import java
from javax.swing import ListCellRenderer
from javax.swing import JLabel
from javax.swing.border import EmptyBorder
from javax.swing import UIManager
from java.awt import Color
from java.awt.event import MouseAdapter
from java.awt.event import WindowAdapter
import os


class ExitListener(WindowAdapter):
	def __init__(self):
		WindowAdapter.__init__(self)
	def windowClosing(self, e):
		java.lang.System.exit(0)

class DbclickListener(MouseAdapter):
	def __init__(self, frame):
		self.frameSource = frame
	
	def mouseClicked(self, event):
		if (event.getClickCount() == 2):
			self.frameSource.locationSelected(event.getPoint())



class FindListRenderer(JLabel,ListCellRenderer):
	def __init__(self):
		JLabel.__init__(self)
		self.noFocusBorder = EmptyBorder(1, 1, 1, 1)
		self.setBorder(self.noFocusBorder)
		self.setOpaque(1)
		self.matchColor = Color(153,0,0)
		

	def getListCellRendererComponent(self, list,value,index,isSelected,cellHasFocus):
		self.setText(str(value))
		self.setFont(list.getFont())
		
		if isSelected:
			self.setBackground(list.getSelectionBackground())
			self.setForeground(list.getSelectionForeground())
		else:
			self.setBackground(list.getBackground())
			self.setForeground(list.getForeground())

		if cellHasFocus:
			self.setBorder(UIManager.getBorder("List.focusCellHighlightBorder"))
		else:
			self.setBorder(self.noFocusBorder)
		return self
	
	def paint(self, graphics):
		self.fm = graphics.getFontMetrics();
		graphics.setColor(self.getBackground())
		graphics.fillRect(0,0,self.getWidth(),self.getHeight())
		self.getBorder().paintBorder(self,graphics,0,0,self.getWidth(),self.getHeight())
		graphics.setFont(self.getFont())
		self.minsets = self.getInsets()
		x = self.minsets.left
		y = self.minsets.top+self.fm.getAscent()

		graphics.setColor(Color.black)
		t = os.path.dirname(self.getText())
		graphics.drawString(t+os.sep,x,y)
		x = x + self.fm.stringWidth(t+os.sep)

		graphics.setColor(self.matchColor)
		graphics.drawString(os.path.basename(self.getText()),x,y)






