#!env python
"""
Copyright (C) 2000 Frdric Laurent

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

mailto:flrt@free.fr
"""

from java import awt

from java.awt.event import ActionListener
from java.awt import BorderLayout
from java.awt import GridLayout
from java.awt import Dimension
from javax.swing import *

import pyFind
import java
import sys
import os
import string

from FindData.FindDataModel import *
from SwingAdapter.Adapters import *


class FindGui(JFrame, ActionListener):
	def __init__(self,title):
		JFrame.__init__(self,title, visible=1)
		self.dataModel = FindDataModel()
		self.foundlist = None
		self.finder = pyFind.FileFind()
		self.addWindowListener(ExitListener())

	def getPreferredSize(self): return Dimension(400,400)

	def buildData(self):
		self.dataModel.clear()
		for i in self.finder.getFoundFiles():
			self.dataModel.addElement(i)
		self.dataModel.updateData()

	
	def buildGui(self):
  		# label
  		labelPanel = JPanel(layout=GridLayout(3,0))
		for label in ["o","quoi","faire"]:
			labelPanel.add(JLabel(label))
			
  		# textfield
  		textPanel = JPanel(layout=GridLayout(3,0))
  		self.whereText = JTextField()
  		self.whatText = JTextField()
  		self.bindingText = JTextField()
  		textPanel.add(self.whereText)
  		textPanel.add(self.whatText)
  		textPanel.add(self.bindingText)
		
  		# button
  		fctPanel = JPanel(layout=GridLayout(2,0))
  		self.searchButton = swing.JButton("Recherche")
  		self.searchButton.addActionListener(self)
		
  		fctPanel.add(self.searchButton)
		
  		topPanel = JPanel(layout=BorderLayout())
  		topPanel.setBackground(Color.gray)
  		topPanel.add("West",labelPanel)
  		topPanel.add("Center",textPanel)
  		topPanel.add("East",fctPanel)
		
  		# list
  		self.foundlist = JList(self.dataModel)
  		self.foundlist.setCellRenderer(FindListRenderer())
  		scrollp = JScrollPane(self.foundlist)
  		self.foundlist.addMouseListener(DbclickListener(self))
		
  		self.contentPane.add("North",topPanel)
  		self.contentPane.add("Center",scrollp)

  		self.pack()


	def actionPerformed(self, event):
		if (event.getSource()==self.searchButton):
			self.finder.setPath(self.whereText.getText())
			self.finder.setExprFile(self.whatText.getText())
			self.finder.process()
			self.buildData()

	def locationSelected(self, point):
		if len(self.bindingText.getText()):
			index = self.foundlist.locationToIndex(point)
			val = self.dataModel.getElementAt(index)
			cmd = self.bindingText.getText()+" "+self.whereText.getText()+os.sep+val
			try:
				java.lang.Runtime.getRuntime().exec(cmd)
			except java.io.IOException:
				print "Erreur execution "

		
if __name__=="__main__":
	pf = pyFind.FileFind()
	frame = FindGui('Recherche...')
	frame.buildGui()
	frame.buildData()

			


