#!env python
"""
Copyright (C) 2000 Frdric Laurent

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

mailto:flrt@free.fr
"""

import string
import os.path
import os
import re
import sys

class FileFind:
	def __init__(self):
		self.path = None
		self.exprFile = None
		self.RegExprFile = None
		self.foundfiles = []

	def setPath(self,p): self.path=p
	def getFoundFiles(self): return self.foundfiles

	def simplifyRegExpr(self, r):
		""" traduction en expression reguliere simplifiee """
		self.exprFile=string.replace(r,".","\.")
		self.exprFile=string.replace(self.exprFile,"*",".*")

	def setExprFile(self,r,simplified=None):
		if simplified:
			self.simplifyRegExpr(r)
		else:
			self.exprFile=r

	def fileAnalysis(self,arg, dirname, names):
		for fic in names:
			filename = dirname+os.sep+fic
			if os.path.isfile(filename) and not os.path.islink(filename) \
			   and self.RegExprFile.search(filename):
				self.foundfiles.append(string.replace(filename,arg+os.sep,''))

	def process(self):
		""" compilation de l'expression regulier : gain vitesse """
		del self.foundfiles
		self.foundfiles = []
		self.RegExprFile = re.compile(self.exprFile,re.VERBOSE)
		os.path.walk(self.path,self.fileAnalysis,self.path)

if __name__=="__main__":
	if len(sys.argv) > 2:
		p = FileFind()
		p.setPath(sys.argv[1])
		p.setExprFile(sys.argv[2])
		p.process()
		print p.getFoundFiles()
			
			

			
